function f = objective(x,Tt)
Dat =  [     0,          0,            0,          0,           0,          -pi/2   ;
             0,         -7.228,      466.883,      0,         -pi/2,          0     ;
             0,          0,           26.0,        x(1),       x(2),          0     ;
             0,          0,          123.41,       x(3),    0.163+x(4),      x(5)   ;
             0,          0,          298.44,       x(6),        0,           x(7)   ;
             0,          0,          269.9,        x(8),       x(9),          0     ;
          0.652031,      16.5566,     69.7785,    -1.4970,      0,           pi/2   ];
R1 = [0,0,-1;0,1,0;1,0,0];
Tl(:,:,1) = [   rotate(Dat(1,4:6)) Dat(1,1:3)'; 0, 0, 0, 1];
Tl(:,:,2) = [   rotate(Dat(2,4:6)) Dat(2,1:3)'; 0, 0, 0, 1];
Tl(:,:,3) = [   rotate(Dat(3,4:6)) Dat(3,1:3)'; 0, 0, 0, 1];
Tl(:,:,4) = [R1*rotate(Dat(4,4:6)) Dat(4,1:3)'; 0, 0, 0, 1];
Tl(:,:,5) = [   rotate(Dat(5,4:6)) Dat(5,1:3)'; 0, 0, 0, 1];
Tl(:,:,6) = [   rotate(Dat(6,4:6)) Dat(6,1:3)'; 0, 0, 0, 1];
Tl(:,:,7) = [   rotate(Dat(7,4:6)) Dat(7,1:3)'; 0, 0, 0, 1];
Tg = Tl(:,:,1)*Tl(:,:,2)*Tl(:,:,3)*Tl(:,:,4)*Tl(:,:,5)*Tl(:,:,6)*Tl(:,:,7);

diffmatrix = Tt-Tg;
diffpos = diffmatrix(1:3,4)/10;
diffx   = diffmatrix(1:3,1);
diffy   = diffmatrix(1:3,2);

Pp = dot(diffpos,diffpos);
Po = 25*(dot(diffx,diffx)+dot(diffy,diffy));
f = Pp + Po;

function A = rotate(a)
    A1 = [1,0,0;0,cos(a(1)),-sin(a(1));0,sin(a(1)),cos(a(1))];
    A2 = [cos(a(2)),0,sin(a(2));0,1,0;-sin(a(2)),0,cos(a(2))];
    A3 = [cos(a(3)),-sin(a(3)),0;sin(a(3)),cos(a(3)),0;0,0,1];
    A = A1 * A2 * A3;